
/*
  Remote VPLUS invocation facility
  Version 1.0 / 04.apr.02 - 20.apr.02
  Copyright (C) 2002  Lars Appel

  This package is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This package is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this package; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class Defs {

  final static int BUF_SZ = 16384 /* eg */;

  final static int COMAREA_SZ = 2*85;

  final static int R_VCHANGEFIELD  = 0x01;
  final static int R_VCLOSEBATCH   = 0x02;
  final static int R_VCLOSEFORMF   = 0x03;
  final static int R_VCLOSETERM    = 0x04;
  final static int R_VERRMSG       = 0x05;
  final static int R_VFIELDEDITS   = 0x06;
  final static int R_VFINISHFORM   = 0x07;
  final static int R_VGETBUFFER    = 0x08;
  final static int R_VGETFIELD     = 0x09;
  final static int R_VGETFIELDINFO = 0x0a;
  final static int R_VGETFILEINFO  = 0x0b;
  final static int R_VGETFORMINFO  = 0x0c;
  final static int R_VGETKEYLABELS = 0x0d;
  final static int R_VGETLANG      = 0x0e;
  final static int R_VGETNEXTFORM  = 0x0f;
  final static int R_VGETINT       = 0x10;
  final static int R_VGETDINT      = 0x11;
  final static int R_VGETREAL      = 0x12;
  final static int R_VGETLONG      = 0x13;
  final static int R_VGETPACKED    = 0x14;
  final static int R_VGETZONED     = 0x15;
  final static int R_VGETYYMMDD    = 0x16;
  final static int R_VGETYYYYMMDD  = 0x17;
  final static int R_VINITFORM     = 0x18;
  final static int R_VLOADFORMS    = 0x19;
  final static int R_VOPENBATCH    = 0x1a;
  final static int R_VOPENFORMF    = 0x1b;
  final static int R_VOPENTERM     = 0x1c;
  final static int R_VPLACECURSOR  = 0x1d;
  final static int R_VPOSTBATCH    = 0x1e;
  final static int R_VPRINTFORM    = 0x1f;
  final static int R_VPRINTSCREEN  = 0x20;
  final static int R_VPUTBUFFER    = 0x21;
  final static int R_VPUTFIELD     = 0x22;
  final static int R_VPUTINT       = 0x23;
  final static int R_VPUTDINT      = 0x24;
  final static int R_VPUTREAL      = 0x25;
  final static int R_VPUTLONG      = 0x26;
  final static int R_VPUTPACKED    = 0x27;
  final static int R_VPUTZONED     = 0x28;
  final static int R_VPUTYYMMDD    = 0x29;
  final static int R_VPUTYYYYMMDD  = 0x2a;
  final static int R_VPUTWINDOW    = 0x2b;
  final static int R_VREADBATCH    = 0x2c;
  final static int R_VREADFIELDS   = 0x2d;
  final static int R_VSETERROR     = 0x2e;
  final static int R_VSETKEYLABEL  = 0x2f;
  final static int R_VSETKEYLABELS = 0x30;
  final static int R_VSETLANG      = 0x31;
  final static int R_VSHOWFORM     = 0x32;
  final static int R_VUNLOADFORM   = 0x33;
  final static int R_VWRITEBATCH   = 0x34;

  final static int R_VTURNOFF      = 0x35;
  final static int R_VTURNON       = 0x36;
  final static int R_HP32209       = 0x37;

  final static int R_VGETIEEEREAL  = 0x38;
  final static int R_VGETIEEELONG  = 0x39;
  final static int R_VPUTIEEEREAL  = 0x3a;
  final static int R_VPUTIEEELONG  = 0x3b;

  final static int R_VBLOCKWRITE   = 0x3c;
  final static int R_VBLOCKREAD    = 0x3d;

  final static int R_VGETSAVEFIELD = 0x3e;
  final static int R_VPUTSAVEFIELD = 0x3f;

  final static int R_FINISH        = 0x80;

  static String toString(int req) {
    switch (req) {
      case R_VCHANGEFIELD  : return "R_VCHANGEFIELD  ";
      case R_VCLOSEBATCH   : return "R_VCLOSEBATCH   ";
      case R_VCLOSEFORMF   : return "R_VCLOSEFORMF   ";
      case R_VCLOSETERM    : return "R_VCLOSETERM    ";
      case R_VERRMSG       : return "R_VERRMSG       ";
      case R_VFIELDEDITS   : return "R_VFIELDEDITS   ";
      case R_VFINISHFORM   : return "R_VFINISHFORM   ";
      case R_VGETBUFFER    : return "R_VGETBUFFER    ";
      case R_VGETFIELD     : return "R_VGETFIELD     ";
      case R_VGETFIELDINFO : return "R_VGETFIELDINFO ";
      case R_VGETFILEINFO  : return "R_VGETFILEINFO  ";
      case R_VGETFORMINFO  : return "R_VGETFORMINFO  ";
      case R_VGETKEYLABELS : return "R_VGETKEYLABELS ";
      case R_VGETLANG      : return "R_VGETLANG      ";
      case R_VGETNEXTFORM  : return "R_VGETNEXTFORM  ";
      case R_VGETINT       : return "R_VGETINT       ";
      case R_VGETDINT      : return "R_VGETDINT      ";
      case R_VGETREAL      : return "R_VGETREAL      ";
      case R_VGETLONG      : return "R_VGETLONG      ";
      case R_VGETPACKED    : return "R_VGETPACKED    ";
      case R_VGETZONED     : return "R_VGETZONED     ";
      case R_VGETYYMMDD    : return "R_VGETYYMMDD    ";
      case R_VGETYYYYMMDD  : return "R_VGETYYYYMMDD  ";
      case R_VINITFORM     : return "R_VINITFORM     ";
      case R_VLOADFORMS    : return "R_VLOADFORMS    ";
      case R_VOPENBATCH    : return "R_VOPENBATCH    ";
      case R_VOPENFORMF    : return "R_VOPENFORMF    ";
      case R_VOPENTERM     : return "R_VOPENTERM     ";
      case R_VPLACECURSOR  : return "R_VPLACECURSOR  ";
      case R_VPOSTBATCH    : return "R_VPOSTBATCH    ";
      case R_VPRINTFORM    : return "R_VPRINTFORM    ";
      case R_VPRINTSCREEN  : return "R_VPRINTSCREEN  ";
      case R_VPUTBUFFER    : return "R_VPUTBUFFER    ";
      case R_VPUTFIELD     : return "R_VPUTFIELD     ";
      case R_VPUTINT       : return "R_VPUTINT       ";
      case R_VPUTDINT      : return "R_VPUTDINT      ";
      case R_VPUTREAL      : return "R_VPUTREAL      ";
      case R_VPUTLONG      : return "R_VPUTLONG      ";
      case R_VPUTPACKED    : return "R_VPUTPACKED    ";
      case R_VPUTZONED     : return "R_VPUTZONED     ";
      case R_VPUTYYMMDD    : return "R_VPUTYYMMDD    ";
      case R_VPUTYYYYMMDD  : return "R_VPUTYYYYMMDD  ";
      case R_VPUTWINDOW    : return "R_VPUTWINDOW    ";
      case R_VREADBATCH    : return "R_VREADBATCH    ";
      case R_VREADFIELDS   : return "R_VREADFIELDS   ";
      case R_VSETERROR     : return "R_VSETERROR     ";
      case R_VSETKEYLABEL  : return "R_VSETKEYLABEL  ";
      case R_VSETKEYLABELS : return "R_VSETKEYLABELS ";
      case R_VSETLANG      : return "R_VSETLANG      ";
      case R_VSHOWFORM     : return "R_VSHOWFORM     ";
      case R_VUNLOADFORM   : return "R_VUNLOADFORM   ";
      case R_VWRITEBATCH   : return "R_VWRITEBATCH   ";

      case R_VTURNOFF      : return "R_VTURNOFF      ";
      case R_VTURNON       : return "R_VTURNON       ";
      case R_HP32209       : return "R_HP32209       ";

      case R_VGETIEEEREAL  : return "R_VGETIEEEREAL  ";
      case R_VGETIEEELONG  : return "R_VGETIEEELONG  ";
      case R_VPUTIEEEREAL  : return "R_VPUTIEEEREAL  ";
      case R_VPUTIEEELONG  : return "R_VPUTIEEELONG  ";

      case R_VBLOCKWRITE   : return "R_VBLOCKWRITE   ";
      case R_VBLOCKREAD    : return "R_VBLOCKREAD    ";

      case R_VGETSAVEFIELD : return "R_VGETSAVEFIELD ";
      case R_VPUTSAVEFIELD : return "R_VPUTSAVEFIELD ";

      case R_FINISH        : return "R_FINISH        ";
    }
    return "UNKNOWN";
  }

}

