
/*
  Remote VPLUS invocation facility
  Version 1.0 / 16.mar.02 - 20.apr.02
  Copyright (C) 2002  Lars Appel

  This package is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This package is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this package; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

#define PRE(x) int req; cli_init(); req=x; buf_put1st(&req, 4);
#define PUT(x,y) buf_putnxt(x, y);
#define RPC buf_send(); buf_recv(); /* skip */ buf_ref1st();
#define GET(x) buf_getnxt(x);


void vchangefield (void *comarea, void *specbuffer, short *numentries) {
  PRE(R_VCHANGEFIELD); 
  PUT(comarea, COMAREA_SZ);
  PUT(specbuffer, *numentries * 8);
  PUT(numentries, 2);
  RPC; 
  GET(comarea);
  GET(specbuffer);
  GET(numentries);
}

void vclosebatch (void *comarea) {
  PRE(R_VCLOSEBATCH); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vcloseformf (void *comarea) {
  PRE(R_VCLOSEFORMF); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vcloseterm (void *comarea) {
  PRE(R_VCLOSETERM); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void verrmsg (void *comarea, void *buffer, short *buflen, short *actualen) {
  PRE(R_VERRMSG); 
  PUT(comarea, COMAREA_SZ);
  PUT(buffer, *buflen);
  PUT(buflen, 2);
  PUT(actualen, 2);
  RPC; 
  GET(comarea);
  GET(buffer);
  GET(buflen);
  GET(actualen);
}

void vfieldedits (void *comarea) {
  PRE(R_VFIELDEDITS); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vfinishform (void *comarea) {
  PRE(R_VFINISHFORM); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vgetbuffer (void *comarea, void *buffer, short *buflen) {
  PRE(R_VGETBUFFER); 
  PUT(comarea, COMAREA_SZ);
  PUT(buffer, *buflen);
  PUT(buflen, 2);
  RPC; 
  GET(comarea);
  GET(buffer);
  GET(buflen);
}

void vgetfield (void *comarea, short *fieldnum, void *fieldbuf, short *buflen, short *actualen, short *nextfldnum) {
  PRE(R_VGETFIELD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(fieldbuf, *buflen);
  PUT(buflen, 2);
  PUT(actualen, 2);
  PUT(nextfldnum, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(fieldbuf);
  GET(buflen);
  GET(actualen);
  GET(nextfldnum);
}

void vgetfieldinfo (void *comarea, void *infobuf, short *infobuflen) {
  PRE(R_VGETFIELDINFO); 
  PUT(comarea, COMAREA_SZ);
  PUT(infobuf, *infobuflen * 2);
  PUT(infobuflen, 2);
  RPC; 
  GET(comarea);
  GET(infobuf);
  GET(infobuflen);
}

void vgetfileinfo (void *comarea, void *infobuf, short *infobuflen) {
  PRE(R_VGETFILEINFO); 
  PUT(comarea, COMAREA_SZ);
  PUT(infobuf, *infobuflen * 2);
  PUT(infobuflen, 2);
  RPC; 
  GET(comarea);
  GET(infobuf);
  GET(infobuflen);
}

void vgetforminfo (void *comarea, void *infobuf, short *infobuflen) {
  PRE(R_VGETFORMINFO); 
  PUT(comarea, COMAREA_SZ);
  PUT(infobuf, *infobuflen * 2);
  PUT(infobuflen, 2);
  RPC; 
  GET(comarea);
  GET(infobuf);
  GET(infobuflen);
}

void vgetkeylabels (void *comarea, short *formorglob, short *numoflabels, void *labels) {
  PRE(R_VGETKEYLABELS); 
  PUT(comarea, COMAREA_SZ);
  PUT(formorglob, 2);
  PUT(numoflabels, 2);
  PUT(labels, *numoflabels * 16);
  RPC; 
  GET(comarea);
  GET(formorglob);
  GET(numoflabels);
  GET(labels);
}

void vgetlang (void *comarea, short *langnum) {
  PRE(R_VGETLANG); 
  PUT(comarea, COMAREA_SZ);
  PUT(langnum, 2);
  RPC; 
  GET(comarea);
  GET(langnum);
}

void vgetnextform (void *comarea) {
  PRE(R_VGETNEXTFORM); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vgetint (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETINT); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetdint (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETDINT); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetreal (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETREAL); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetlong (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETLONG); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetpacked (void *comarea, short *fieldnum, void *variable, short *numdigits, short *decplaces) {
  PRE(R_VGETPACKED); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, *numdigits / 2);  /* ?? */
  PUT(numdigits, 2);
  PUT(decplaces, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
  GET(numdigits);
  GET(decplaces);
}

void vgetzoned (void *comarea, short *fieldnum, void *variable, short *numdigits, short *decplaces) {
  PRE(R_VGETZONED); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, *numdigits / 2);  /* ?? */
  PUT(numdigits, 2);
  PUT(decplaces, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
  GET(numdigits);
  GET(decplaces);
}

void vgetyymmdd (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETYYMMDD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 6);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetyyyymmdd (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETYYYYMMDD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vinitform (void *comarea) {
  PRE(R_VINITFORM); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vloadforms (void *comarea, short *numofforms, short *formsloaded, void *forms) {
  PRE(R_VLOADFORMS); 
  PUT(comarea, COMAREA_SZ);
  PUT(numofforms, 2);
  PUT(formsloaded, 2);
  PUT(forms, *numofforms * 16);
  RPC; 
  GET(comarea);
  GET(numofforms);
  GET(formsloaded);
  GET(forms);
}

void vopenbatch (void *comarea, void *batchfile) {
  PRE(R_VOPENBATCH); 
  PUT(comarea, COMAREA_SZ);
  PUT(batchfile, 36);
  RPC; 
  GET(comarea);
  GET(batchfile);
}

void vopenformf (void *comarea, void *formfile) {
  PRE(R_VOPENFORMF); 
  PUT(comarea, COMAREA_SZ);
  PUT(formfile, 36);
  RPC; 
  GET(comarea);
  GET(formfile);
}

void vopenterm (void *comarea, void *termfile) {
  PRE(R_VOPENTERM); 
  PUT(comarea, COMAREA_SZ);
  PUT(termfile, 36);
  RPC; 
  GET(comarea);
  GET(termfile);
}

void vplacecursor (void *comarea, short *fieldnum) {
  PRE(R_VPLACECURSOR); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
}

void vpostbatch (void *comarea) {
  PRE(R_VPOSTBATCH); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vprintform (void *comarea, short *printcntl, short *pagecntl) {
  PRE(R_VPRINTFORM); 
  PUT(comarea, COMAREA_SZ);
  PUT(printcntl, 2);
  PUT(pagecntl, 2);
  RPC; 
  GET(comarea);
  GET(printcntl);
  GET(pagecntl);
}

void vprintscreen (void *comarea, short *readsize) {
  PRE(R_VPRINTSCREEN); 
  PUT(comarea, COMAREA_SZ);
  PUT(readsize, 2);
  RPC; 
  GET(comarea);
  GET(readsize);
}

void vputbuffer (void *comarea, void *buffer, short *buflen) {
  PRE(R_VPUTBUFFER); 
  PUT(comarea, COMAREA_SZ);
  PUT(buffer, *buflen);
  PUT(buflen, 2);
  RPC; 
  GET(comarea);
  GET(buffer);
  GET(buflen);
}

void vputfield (void *comarea, short *fieldnum, void *fieldbuf, short *buflen, short *actualen, short *nextfldnum) {
  PRE(R_VPUTFIELD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(fieldbuf, *buflen);
  PUT(buflen, 2);
  PUT(actualen, 2);
  PUT(nextfldnum, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(fieldbuf);
  GET(buflen);
  GET(actualen);
  GET(nextfldnum);
}

void vputint (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTINT); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputdint (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTDINT); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputreal (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTREAL); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputlong (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTLONG); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputpacked (void *comarea, short *fieldnum, void *variable, short *numdigits, short *decplaces) {
  PRE(R_VPUTPACKED); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, *numdigits / 2);  /* ?? */
  PUT(numdigits, 2);
  PUT(decplaces, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
  GET(numdigits);
  GET(decplaces);
}

void vputzoned (void *comarea, short *fieldnum, void *variable, short *numdigits, short *decplaces) {
  PRE(R_VPUTZONED); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, *numdigits);  /* ?? */
  PUT(numdigits, 2);
  PUT(decplaces, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
  GET(numdigits);
  GET(decplaces);
}

void vputyymmdd (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTYYMMDD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 6);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputyyyymmdd (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTYYYYMMDD); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputwindow (void *comarea, void *message, short *length) {
  PRE(R_VPUTWINDOW); 
  PUT(comarea, COMAREA_SZ);
  PUT(message, (*length != 0) ? *length : 1);  /* ?? */
  PUT(length, 2);
  RPC; 
  GET(comarea);
  GET(message);
  GET(length);
}

void vreadbatch (void *comarea) {
  PRE(R_VREADBATCH); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vreadfields (void *comarea) {
  PRE(R_VREADFIELDS); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vseterror (void *comarea, short *fieldnum, void *message, short *msglen) {
  PRE(R_VSETERROR); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(message, (*msglen < 1) ? 1 : *msglen);
  PUT(msglen, 2);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(message);
  GET(msglen);
}

void vsetkeylabel (void *comarea, short *formorglob, short *keynum, void *label) {
  PRE(R_VSETKEYLABEL); 
  PUT(comarea, COMAREA_SZ);
  PUT(formorglob, 2);
  PUT(keynum, 2);
  PUT(label, 16);
  RPC; 
  GET(comarea);
  GET(formorglob);
  GET(keynum);
  GET(label);
}

void vsetkeylabels (void *comarea, short *formorglob, short *numoflabels, void *labels) {
  PRE(R_VSETKEYLABELS); 
  PUT(comarea, COMAREA_SZ);
  PUT(formorglob, 2);
  PUT(numoflabels, 2);
  PUT(labels, (*numoflabels > 0) ? *numoflabels : 1);
  RPC; 
  GET(comarea);
  GET(formorglob);
  GET(numoflabels);
  GET(labels);
}

void vsetlang (void *comarea, short langnumByVal, short *errorcode) {
  /* !! */  short langnum;
            PRE(R_VSETLANG); 
  /* !! */  langnum = langnumByVal;
            PUT(comarea, COMAREA_SZ);
  /* !! */  PUT(&langnum, 2);
            PUT(errorcode, 2);
            RPC; 
            GET(comarea);
  /* !! */  GET(&langnum);
            GET(errorcode);
}

void vshowform (void *comarea) {
  PRE(R_VSHOWFORM); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vunloadform (void *comarea, void *whichform) {
  PRE(R_VUNLOADFORM); 
  PUT(comarea, COMAREA_SZ);
  PUT(whichform, 16);
  RPC; 
  GET(comarea);
  GET(whichform);
}

void vwritebatch (void *comarea) {
  PRE(R_VWRITEBATCH); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}


void vturnoff (void *comarea) {
  PRE(R_VTURNOFF); 
  PUT(comarea, COMAREA_SZ);
  RPC; 
  GET(comarea);
}

void vturnon (void *comarea, void *termfile) {
  PRE(R_VTURNON); 
  PUT(comarea, COMAREA_SZ);
  PUT(termfile, 36);
  RPC; 
  GET(comarea);
  GET(termfile);
}

void hp32209 (void *buffer) {
  PRE(R_HP32209); 
  PUT(buffer, 14);
  RPC; 
  GET(buffer);
}


void vgetieeereal (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETIEEEREAL); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vgetieeelong (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VGETIEEELONG); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputieeereal (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTIEEEREAL); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 4);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}

void vputieeelong (void *comarea, short *fieldnum, void *variable) {
  PRE(R_VPUTIEEELONG); 
  PUT(comarea, COMAREA_SZ);
  PUT(fieldnum, 2);
  PUT(variable, 8);
  RPC; 
  GET(comarea);
  GET(fieldnum);
  GET(variable);
}


void vblockwrite (void *comarea, void *buf, short *len, short *tmode, void *loc, short *tc) {
  PRE(R_VBLOCKWRITE); 
  PUT(comarea, COMAREA_SZ);
  PUT(buf, *len);
  PUT(len, 2);
  PUT(tmode, 2);
  PUT(loc, 4);
  PUT(tc, 2);
  RPC; 
  GET(comarea);
  GET(buf);
  GET(len);
  GET(tmode);
  GET(loc);
  GET(tc);
}

void vblockread (void *comarea, void *buf, short *len, short *actlen, short *tmode, void *loc, short *bc, short *tc) {
  PRE(R_VBLOCKREAD); 
  PUT(comarea, COMAREA_SZ);
  PUT(buf, *len);
  PUT(len, 2);
  PUT(actlen, 2);
  PUT(tmode, 2);
  PUT(loc, 4);
  PUT(bc, 2);
  PUT(tc, 2);
  RPC; 
  GET(comarea);
  GET(buf);
  GET(len);
  GET(actlen);
  GET(tmode);
  GET(loc);
  GET(bc);
  GET(tc);
}


void vgetsavefield (void *comarea, void *sfname, void *sfbuf, short *buflen, short *actualen) {
  PRE(R_VGETSAVEFIELD); 
  PUT(comarea, COMAREA_SZ);
  PUT(sfname, 16);
  PUT(sfbuf, *buflen);
  PUT(buflen, 2);
  PUT(actualen, 2);
  RPC; 
  GET(comarea);
  GET(sfname);
  GET(sfbuf);
  GET(buflen);
  GET(actualen);
}

void vputsavefield (void *comarea, void *sfname, void *sfbuf, short *buflen, short *actualen) {
  PRE(R_VPUTSAVEFIELD); 
  PUT(comarea, COMAREA_SZ);
  PUT(sfname, 16);
  PUT(sfbuf, *buflen);
  PUT(buflen, 2);
  PUT(actualen, 2);
  RPC; 
  GET(comarea);
  GET(sfname);
  GET(sfbuf);
  GET(buflen);
  GET(actualen);
}


#ifdef U384

void U384VOPENTERM (void *comarea, void *termfile) {
  vopenterm (comarea, termfile);
}

void U384VCLOSETERM (void *comarea) {
  vcloseterm (comarea);
}

void U384VOPENFORMF (void *comarea, void *formfile) {
  vopenformf (comarea, formfile);
}

void U384READFIELDS (void *comarea) {
  vreadfields (comarea);
}

#endif

