
/*
  Remote VPLUS invocation facility
  Version 1.0 / 04.apr.02 - 20.apr.02
  Copyright (C) 2002  Lars Appel

  This package is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This package is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this package; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define BUF_SZ 16384 /* eg */

#define COMAREA_SZ 2*85

#define R_VCHANGEFIELD  0x01
#define R_VCLOSEBATCH   0x02
#define R_VCLOSEFORMF   0x03
#define R_VCLOSETERM    0x04
#define R_VERRMSG       0x05
#define R_VFIELDEDITS   0x06
#define R_VFINISHFORM   0x07
#define R_VGETBUFFER    0x08
#define R_VGETFIELD     0x09
#define R_VGETFIELDINFO 0x0a
#define R_VGETFILEINFO  0x0b
#define R_VGETFORMINFO  0x0c
#define R_VGETKEYLABELS 0x0d
#define R_VGETLANG      0x0e
#define R_VGETNEXTFORM  0x0f
#define R_VGETINT       0x10
#define R_VGETDINT      0x11
#define R_VGETREAL      0x12
#define R_VGETLONG      0x13
#define R_VGETPACKED    0x14
#define R_VGETZONED     0x15
#define R_VGETYYMMDD    0x16
#define R_VGETYYYYMMDD  0x17
#define R_VINITFORM     0x18
#define R_VLOADFORMS    0x19
#define R_VOPENBATCH    0x1a
#define R_VOPENFORMF    0x1b
#define R_VOPENTERM     0x1c
#define R_VPLACECURSOR  0x1d
#define R_VPOSTBATCH    0x1e
#define R_VPRINTFORM    0x1f
#define R_VPRINTSCREEN  0x20
#define R_VPUTBUFFER    0x21
#define R_VPUTFIELD     0x22
#define R_VPUTINT       0x23
#define R_VPUTDINT      0x24
#define R_VPUTREAL      0x25
#define R_VPUTLONG      0x26
#define R_VPUTPACKED    0x27
#define R_VPUTZONED     0x28
#define R_VPUTYYMMDD    0x29
#define R_VPUTYYYYMMDD  0x2a
#define R_VPUTWINDOW    0x2b
#define R_VREADBATCH    0x2c
#define R_VREADFIELDS   0x2d
#define R_VSETERROR     0x2e
#define R_VSETKEYLABEL  0x2f
#define R_VSETKEYLABELS 0x30
#define R_VSETLANG      0x31
#define R_VSHOWFORM     0x32
#define R_VUNLOADFORM   0x33
#define R_VWRITEBATCH   0x34

#define R_VTURNOFF      0x35
#define R_VTURNON       0x36
#define R_HP32209       0x37

#define R_VGETIEEEREAL  0x38
#define R_VGETIEEELONG  0x39
#define R_VPUTIEEEREAL  0x3a
#define R_VPUTIEEELONG  0x3b

#define R_VBLOCKWRITE   0x3c
#define R_VBLOCKREAD    0x3d

#define R_VGETSAVEFIELD 0x3e
#define R_VPUTSAVEFIELD 0x3f

#define R_FINISH        0x80

#define OK 0


void buf_put1st(void *adr, int len);
void buf_putnxt(void *adr, int len);

void *buf_ref1st();
void *buf_refnxt();

void buf_get1st(void *adr);
void buf_getnxt(void *adr);

void buf_send();
void buf_recv();

void srv_init();
void srv_exit();

void cli_init();
void cli_exit();

