
/*
  Remote VPLUS invocation facility
  Version 1.0 / 16.mar.02 - 18.apr.02
  Copyright (C) 2002  Lars Appel

  This package is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This package is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this package; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

#define DEF /* just a mark */
#define USE(x) x=buf_refnxt();


void h_vchangefield () {
  DEF void *comarea;
  DEF void *specbuffer;
  DEF void *numentries;
  USE(comarea);
  USE(specbuffer);
  USE(numentries);
  vchangefield (comarea, specbuffer, numentries);
}

void h_vclosebatch () {
  DEF void *comarea;
  USE(comarea);
  vclosebatch (comarea);
}

void h_vcloseformf () {
  DEF void *comarea;
  USE(comarea);
  vcloseformf (comarea);
}

void h_vcloseterm () {
  DEF void *comarea;
  USE(comarea);
  vcloseterm (comarea);
}

void h_verrmsg () {
  DEF void *comarea;
  DEF void *buffer;
  DEF void *buflen;
  DEF void *actualen;
  USE(comarea);
  USE(buffer);
  USE(buflen);
  USE(actualen);
  verrmsg (comarea, buffer, buflen, actualen);
}

void h_vfieldedits () {
  DEF void *comarea;
  USE(comarea);
  vfieldedits (comarea);
}

void h_vfinishform () {
  DEF void *comarea;
  USE(comarea);
  vfinishform (comarea);
}

void h_vgetbuffer () {
  DEF void *comarea;
  DEF void *buffer;
  DEF void *buflen;
  USE(comarea);
  USE(buffer);
  USE(buflen);
  vgetbuffer (comarea, buffer, buflen);
}

void h_vgetfield () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *fieldbuf;
  DEF void *buflen;
  DEF void *actualen;
  DEF void *nextfldnum;
  USE(comarea);
  USE(fieldnum);
  USE(fieldbuf);
  USE(buflen);
  USE(actualen);
  USE(nextfldnum);
  vgetfield (comarea, fieldnum, fieldbuf, buflen, actualen, nextfldnum);
}

void h_vgetfieldinfo () {
  DEF void *comarea;
  DEF void *infobuf;
  DEF void *infobuflen;
  USE(comarea);
  USE(infobuf);
  USE(infobuflen);
  vgetfieldinfo (comarea, infobuf, infobuflen);
}

void h_vgetfileinfo () {
  DEF void *comarea;
  DEF void *infobuf;
  DEF void *infobuflen;
  USE(comarea);
  USE(infobuf);
  USE(infobuflen);
  vgetfileinfo (comarea, infobuf, infobuflen);
}

void h_vgetforminfo () {
  DEF void *comarea;
  DEF void *infobuf;
  DEF void *infobuflen;
  USE(comarea);
  USE(infobuf);
  USE(infobuflen);
  vgetforminfo (comarea, infobuf, infobuflen);
}

void h_vgetkeylabels () {
  DEF void *comarea;
  DEF void *formorglob;
  DEF void *numoflabels;
  DEF void *labels;
  USE(comarea);
  USE(formorglob);
  USE(numoflabels);
  USE(labels);
  vgetkeylabels (comarea, formorglob, numoflabels, labels);
}

void h_vgetlang () {
  DEF void *comarea;
  DEF void *langnum;
  USE(comarea);
  USE(langnum);
  vgetlang (comarea, langnum);
}

void h_vgetnextform () {
  DEF void *comarea;
  USE(comarea);
  vgetnextform (comarea);
}

void h_vgetint () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetint (comarea, fieldnum, variable);
}

void h_vgetdint () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetdint (comarea, fieldnum, variable);
}

void h_vgetreal () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetreal (comarea, fieldnum, variable);
}

void h_vgetlong () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetlong (comarea, fieldnum, variable);
}

void h_vgetpacked () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  DEF void *numdigits;
  DEF void *decplaces;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  USE(numdigits);
  USE(decplaces);
  vgetpacked (comarea, fieldnum, variable, numdigits, decplaces);
}

void h_vgetzoned () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  DEF void *numdigits;
  DEF void *decplaces;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  USE(numdigits);
  USE(decplaces);
  vgetzoned (comarea, fieldnum, variable, numdigits, decplaces);
}

void h_vgetyymmdd () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetyymmdd (comarea, fieldnum, variable);
}

void h_vgetyyyymmdd () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetyyyymmdd (comarea, fieldnum, variable);
}

void h_vinitform () {
  DEF void *comarea;
  USE(comarea);
  vinitform (comarea);
}

void h_vloadforms () {
  DEF void *comarea;
  DEF void *numofforms;
  DEF void *formsloaded;
  DEF void *forms;
  USE(comarea);
  USE(numofforms);
  USE(formsloaded);
  USE(forms);
  vloadforms (comarea, numofforms, formsloaded, forms);
}

void h_vopenbatch () {
  DEF void *comarea;
  DEF void *batchfile;
  USE(comarea);
  USE(batchfile);
  vopenbatch (comarea, batchfile);
}

void h_vopenformf () {
  DEF void *comarea;
  DEF void *formfile;
  USE(comarea);
  USE(formfile);
  vopenformf (comarea, formfile);
}

void h_vopenterm () {
  DEF void *comarea;
  DEF void *termfile;
  USE(comarea);
  USE(termfile);
  vopenterm (comarea, termfile);
}

void h_vplacecursor () {
  DEF void *comarea;
  DEF void *fieldnum;
  USE(comarea);
  USE(fieldnum);
  vplacecursor (comarea, fieldnum);
}

void h_vpostbatch () {
  DEF void *comarea;
  USE(comarea);
  vpostbatch (comarea);
}

void h_vprintform () {
  DEF void *comarea;
  DEF void *printcntl;
  DEF void *pagecntl;
  USE(comarea);
  USE(printcntl);
  USE(pagecntl);
  vprintform (comarea, printcntl, pagecntl);
}

void h_vprintscreen () {
  DEF void *comarea;
  DEF void *readsize;
  USE(comarea);
  USE(readsize);
  vprintscreen (comarea, readsize);
}

void h_vputbuffer () {
  DEF void *comarea;
  DEF void *buffer;
  DEF void *buflen;
  USE(comarea);
  USE(buffer);
  USE(buflen);
  vputbuffer (comarea, buffer, buflen);
}

void h_vputfield () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *fieldbuf;
  DEF void *buflen;
  DEF void *actualen;
  DEF void *nextfldnum;
  USE(comarea);
  USE(fieldnum);
  USE(fieldbuf);
  USE(buflen);
  USE(actualen);
  USE(nextfldnum);
  vputfield (comarea, fieldnum, fieldbuf, buflen, actualen, nextfldnum);
}

void h_vputint () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputint (comarea, fieldnum, variable);
}

void h_vputdint () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputdint (comarea, fieldnum, variable);
}

void h_vputreal () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputreal (comarea, fieldnum, variable);
}

void h_vputlong () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputlong (comarea, fieldnum, variable);
}

void h_vputpacked () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  DEF void *numdigits;
  DEF void *decplaces;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  USE(numdigits);
  USE(decplaces);
  vputpacked (comarea, fieldnum, variable, numdigits, decplaces);
}

void h_vputzoned () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  DEF void *numdigits;
  DEF void *decplaces;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  USE(numdigits);
  USE(decplaces);
  vputzoned (comarea, fieldnum, variable, numdigits, decplaces);
}

void h_vputyymmdd () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputyymmdd (comarea, fieldnum, variable);
}

void h_vputyyyymmdd () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputyyyymmdd (comarea, fieldnum, variable);
}

void h_vputwindow () {
  DEF void *comarea;
  DEF void *message;
  DEF void *length;
  USE(comarea);
  USE(message);
  USE(length);
  vputwindow (comarea, message, length);
}

void h_vreadbatch () {
  DEF void *comarea;
  USE(comarea);
  vreadbatch (comarea);
}

void h_vreadfields () {
  DEF void *comarea;
  USE(comarea);
  vreadfields (comarea);
}

void h_vseterror () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *message;
  DEF void *msglen;
  USE(comarea);
  USE(fieldnum);
  USE(message);
  USE(msglen);
  vseterror (comarea, fieldnum, message, msglen);
}

void h_vsetkeylabel () {
  DEF void *comarea;
  DEF void *formorglob;
  DEF void *keynum;
  DEF void *label;
  USE(comarea);
  USE(formorglob);
  USE(keynum);
  USE(label);
  vsetkeylabel (comarea, formorglob, keynum, label);
}

void h_vsetkeylabels () {
  DEF void *comarea;
  DEF void *formorglob;
  DEF void *numoflabels;
  DEF void *labels;
  USE(comarea);
  USE(formorglob);
  USE(numoflabels);
  USE(labels);
  vsetkeylabels (comarea, formorglob, numoflabels, labels);
}

void h_vsetlang () {
            DEF void *comarea;
            DEF short *langnum;
            DEF void *errorcode;
            USE(comarea);
            USE(langnum);
            USE(errorcode);
  /* !! */  vsetlang (comarea, *langnum, errorcode);
}

void h_vshowform () {
  DEF void *comarea;
  USE(comarea);
  vshowform (comarea);
}

void h_vunloadform () {
  DEF void *comarea;
  DEF void *whichform;
  USE(comarea);
  USE(whichform);
  vunloadform (comarea, whichform);
}

void h_vwritebatch () {
  DEF void *comarea;
  USE(comarea);
  vwritebatch (comarea);
}


void h_vturnoff () {
  DEF void *comarea;
  USE(comarea);
  vturnoff (comarea);
}

void h_vturnon () {
  DEF void *comarea;
  DEF void *termfile;
  USE(comarea);
  USE(termfile);
  vturnon (comarea, termfile);
}

void h_hp32209 () {
  DEF void *buffer;
  USE(buffer);
  hp32209 (buffer);
}


void h_vgetieeereal () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetieeereal (comarea, fieldnum, variable);
}

void h_vgetieeelong () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vgetieeelong (comarea, fieldnum, variable);
}

void h_vputieeereal () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputieeereal (comarea, fieldnum, variable);
}

void h_vputieeelong () {
  DEF void *comarea;
  DEF void *fieldnum;
  DEF void *variable;
  USE(comarea);
  USE(fieldnum);
  USE(variable);
  vputieeelong (comarea, fieldnum, variable);
}


void h_vblockwrite () {
  DEF void *comarea;
  DEF void *buf;
  DEF void *len;
  DEF void *tmode;
  DEF void *loc;
  DEF void *tc;
  USE(comarea);
  USE(buf);
  USE(len);
  USE(tmode);
  USE(loc);
  USE(tc);
  vblockwrite (comarea, buf, len, tmode, loc, tc);
}

void h_vblockread () {
  DEF void *comarea;
  DEF void *buf;
  DEF void *len;
  DEF void *actlen;
  DEF void *tmode;
  DEF void *loc;
  DEF void *bc;
  DEF void *tc;
  USE(comarea);
  USE(buf);
  USE(len);
  USE(actlen);
  USE(tmode);
  USE(loc);
  USE(bc);
  USE(tc);
  vblockread (comarea, buf, len, actlen, tmode, loc, bc, tc);
}


void h_vgetsavefield () {
  DEF void *comarea;
  DEF void *sfname;
  DEF void *sfbuf;
  DEF void *buflen;
  DEF void *actualen;
  USE(comarea);
  USE(sfname);
  USE(sfbuf);
  USE(buflen);
  USE(actualen);
  vgetsavefield (comarea, sfname, sfbuf, buflen, actualen);
}

void h_vputsavefield () {
  DEF void *comarea;
  DEF void *sfname;
  DEF void *sfbuf;
  DEF void *buflen;
  DEF void *actualen;
  USE(comarea);
  USE(sfname);
  USE(sfbuf);
  USE(buflen);
  USE(actualen);
  vputsavefield (comarea, sfname, sfbuf, buflen, actualen);
}


int srv_body() {
  int *req;
  buf_recv();
  req = buf_ref1st();
  switch (*req) {

    case R_VCHANGEFIELD  : h_vchangefield()  ; break;
    case R_VCLOSEBATCH   : h_vclosebatch()   ; break;
    case R_VCLOSEFORMF   : h_vcloseformf()   ; break;
    case R_VCLOSETERM    : h_vcloseterm()    ; break;
    case R_VERRMSG       : h_verrmsg()       ; break;
    case R_VFIELDEDITS   : h_vfieldedits()   ; break;
    case R_VFINISHFORM   : h_vfinishform()   ; break;
    case R_VGETBUFFER    : h_vgetbuffer()    ; break;
    case R_VGETFIELD     : h_vgetfield()     ; break;
    case R_VGETFIELDINFO : h_vgetfieldinfo() ; break;
    case R_VGETFILEINFO  : h_vgetfileinfo()  ; break;
    case R_VGETFORMINFO  : h_vgetforminfo()  ; break;
    case R_VGETKEYLABELS : h_vgetkeylabels() ; break;
    case R_VGETLANG      : h_vgetlang()      ; break;
    case R_VGETNEXTFORM  : h_vgetnextform()  ; break;
    case R_VGETINT       : h_vgetint()       ; break;
    case R_VGETDINT      : h_vgetdint()      ; break;
    case R_VGETREAL      : h_vgetreal()      ; break;
    case R_VGETLONG      : h_vgetlong()      ; break;
    case R_VGETPACKED    : h_vgetpacked()    ; break;
    case R_VGETZONED     : h_vgetzoned()     ; break;
    case R_VGETYYMMDD    : h_vgetyymmdd()    ; break;
    case R_VGETYYYYMMDD  : h_vgetyyyymmdd()  ; break;
    case R_VINITFORM     : h_vinitform()     ; break;
    case R_VLOADFORMS    : h_vloadforms()    ; break;
    case R_VOPENBATCH    : h_vopenbatch()    ; break;
    case R_VOPENFORMF    : h_vopenformf()    ; break;
    case R_VOPENTERM     : h_vopenterm()     ; break;
    case R_VPLACECURSOR  : h_vplacecursor()  ; break;
    case R_VPOSTBATCH    : h_vpostbatch()    ; break;
    case R_VPRINTFORM    : h_vprintform()    ; break;
    case R_VPRINTSCREEN  : h_vprintscreen()  ; break;
    case R_VPUTBUFFER    : h_vputbuffer()    ; break;
    case R_VPUTFIELD     : h_vputfield()     ; break;
    case R_VPUTINT       : h_vputint()       ; break;
    case R_VPUTDINT      : h_vputdint()      ; break;
    case R_VPUTREAL      : h_vputreal()      ; break;
    case R_VPUTLONG      : h_vputlong()      ; break;
    case R_VPUTPACKED    : h_vputpacked()    ; break;
    case R_VPUTZONED     : h_vputzoned()     ; break;
    case R_VPUTYYMMDD    : h_vputyymmdd()    ; break;
    case R_VPUTYYYYMMDD  : h_vputyyyymmdd()  ; break;
    case R_VPUTWINDOW    : h_vputwindow()    ; break;
    case R_VREADBATCH    : h_vreadbatch()    ; break;
    case R_VREADFIELDS   : h_vreadfields()   ; break;
    case R_VSETERROR     : h_vseterror()     ; break;
    case R_VSETKEYLABEL  : h_vsetkeylabel()  ; break;
    case R_VSETKEYLABELS : h_vsetkeylabels() ; break;
    case R_VSETLANG      : h_vsetlang()      ; break;
    case R_VSHOWFORM     : h_vshowform()     ; break;
    case R_VUNLOADFORM   : h_vunloadform()   ; break;
    case R_VWRITEBATCH   : h_vwritebatch()   ; break;

    case R_VTURNOFF      : h_vturnoff()      ; break;
    case R_VTURNON       : h_vturnon()       ; break;
    case R_HP32209       : h_hp32209()       ; break;

    case R_VGETIEEEREAL  : h_vgetieeereal()  ; break;
    case R_VGETIEEELONG  : h_vgetieeelong()  ; break;
    case R_VPUTIEEEREAL  : h_vputieeereal()  ; break;
    case R_VPUTIEEELONG  : h_vputieeelong()  ; break;

    case R_VBLOCKWRITE   : h_vblockwrite()   ; break;
    case R_VBLOCKREAD    : h_vblockread()    ; break;

    case R_VGETSAVEFIELD : h_vgetsavefield() ; break;
    case R_VPUTSAVEFIELD : h_vputsavefield() ; break;

    case R_FINISH        : return ~OK;
  }
  buf_send();
  return OK;
}


main() {
  srv_init();
  while (0 != 1) {
    srv_wait();
    if (srv_fork() == 0) {
      /* we are the child */
      while (srv_body() == OK) {};
      break;
    }
  }
  srv_exit();
}

