
$STANDARD_LEVEL 'ext_modcal'$

     PROGRAM Pascal_Sample (output);

     TYPE
	pac = packed array [1..256] of char;
        COMAREA_REC = RECORD
          CSTATUS        : shortint;
          LANGUAGE       : shortint;
          COMAREALEN     : shortint;
          USERBUFLEN     : shortint;
          CMODE          : shortint;
          LASTKEY        : shortint;
          NUMERRS        : shortint;
          WINDOWENH      : shortint;
          MULTIUSAGE     : shortint;
          LABELOPTIONS   : shortint;
          CFNAME         : packed array [1..16] of char;
          NFNAME         : packed array [1..16] of char;
          REPEATAPP      : shortint;
          FREEZEAPP      : shortint;
          CFNUMLINES     : shortint;
          DBUFLEN        : shortint;
          SKIP_31        : shortint;
          LOOKAHEAD      : shortint;
          DELETEFLAG     : shortint;
          SHOWCONTROL    : shortint;
          SKIP_35        : shortint;
          PRINTFILENUM   : shortint;
          FILERRNUM      : shortint;
          ERRFILENUM     : shortint;
          FORMSTORESIZE  : shortint;
          SKIP_40        : shortint;
          SKIP_41        : shortint;
          SKIP_42        : shortint;
          NUMRECS        : INTEGER;
          RECNUM         : INTEGER;
          SKIP_47        : shortint;
          SKIP_48        : shortint;
          TERM_FILEN     : shortint;
          SKIP_50        : shortint;
          SKIP_51        : shortint;
          SKIP_52        : shortint;
          SKIP_53        : shortint;
          SKIP_54        : shortint;
          RETRIES        : shortint;
          TERM_OPTIONS   : shortint;
          ENVIRON        : shortint;
          USERTIME       : shortint;
          IDENTIFIER     : shortint;
          LABELINFO      : packed array [1..2] of { byte } char;
            END;

        my_rec_type = record
          fname : packed array [1..20] of char;
          lname : packed array [1..20] of char;
          phone : packed array [1..20] of char;
        end;

     CONST

       COMAREA_INIT = COMAREA_REC
          [ CSTATUS           :  0,
            LANGUAGE          :  5,   {Pascal  }
            COMAREALEN        : 60,
            USERBUFLEN        :  0,
            CMODE             :  0,
            LASTKEY           :  0,
            NUMERRS           :  0,
            WINDOWENH         :  0,
            MULTIUSAGE        :  0,
            LABELOPTIONS      :  1,   {activate labels}
            CFNAME            :  '',
            NFNAME            :  '',
            REPEATAPP         :  0,
            FREEZEAPP         :  0,
            CFNUMLINES        :  0,
            DBUFLEN           :  0,
            SKIP_31           :  0,
            LOOKAHEAD         :  0,   {no form background loading}
            DELETEFLAG        :  0,
            SHOWCONTROL       :  0,
            SKIP_35           :  0,
            PRINTFILENUM      :  0,
            FILERRNUM         :  0,
            ERRFILENUM        :  0,
            FORMSTORESIZE     :  4,   {local form storage}
            SKIP_40           :  0,
            SKIP_41           :  0,
            SKIP_42           :  0,
            NUMRECS           :  0,
            RECNUM            :  0,
            SKIP_47           :  0,
            SKIP_48           :  0,
            TERM_FILEN        :  0,
            SKIP_50           :  0,
            SKIP_51           :  0,
            SKIP_52           :  0,
            SKIP_53           :  0,
            SKIP_54           :  0,
            RETRIES           :  0,
            TERM_OPTIONS      :  0,
            ENVIRON           :  0,
            USERTIME          :  0,
            IDENTIFIER        :  0,
            LABELINFO         :  #0#0
              ];

      VAR
        COMAREA : COMAREA_REC;

        my_rec : my_rec_type;

        my_file : file of my_rec_type;

        formfile : packed array [1..30] of char;
        termfile : packed array [1..30] of char;

        my_buf : record
          fname : packed array [1..20] of char;
          lname : packed array [1..20] of char;
          phone : packed array [1..20] of char;
        end;

        my_len : shortint;
{
        cmdimage : packed array [1..80] of char;
        cmderror : shortint;
        parmnum  : shortint;

     procedure COMMAND                   ; intrinsic;
}
     PROCEDURE VCHANGEFIELD  ; external;

     PROCEDURE VCLOSEFORMF   (anyvar ca: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VCLOSETERM    (anyvar ca: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VERRMSG       ; external;

     PROCEDURE VFIELDEDITS   (anyvar ca: pac)
			       option uncheckable_anyvar; external;

     PROCEDURE VFINISHFORM   (anyvar ca: pac)
			       option uncheckable_anyvar; external;

     PROCEDURE VGETBUFFER    (anyvar ca: pac; anyvar buf: pac; var len: shortint)
                               option uncheckable_anyvar; external;

     procedure vputbuffer    (anyvar ca: pac; anyvar buf: pac; var len: shortint)
                               option uncheckable_anyvar; external;

     PROCEDURE VGETFIELDINFO ; external;

     PROCEDURE VGETNEXTFORM  (anyvar ca: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VINITFORM     ; external;

     PROCEDURE VOPENFORMF    (anyvar ca: pac; anyvar ff: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VOPENTERM     (anyvar ca: pac; anyvar tf: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VPUTWINDOW    ; external;

     PROCEDURE VREADFIELDS   (anyvar ca: pac)
                               option uncheckable_anyvar; external;

     PROCEDURE VSHOWFORM     (anyvar ca: pac)
                               option uncheckable_anyvar; external;

     procedure cli_init; external;
     procedure cli_exit; external;

     BEGIN

     cli_init;

     COMAREA := COMAREA_INIT;

     OPEN (my_file, 'MYFILE');

     readdir (my_file, 1, my_rec);

     formfile := 'formfile ';

     VOPENFORMF (COMAREA, formfile);

     IF COMAREA.CSTATUS <> 0 THEN
        BEGIN
          writeln('cannot open formfile'); halt;
        END;

     termfile := 'termfile ';

     VOPENTERM (COMAREA, termfile);

     IF COMAREA.CSTATUS <> 0 THEN
        BEGIN
          writeln('cannot open termfile'); halt;
        END;

     COMAREA.NFNAME := 'MY_FORM';

     VGETNEXTFORM (COMAREA);

     IF COMAREA.CSTATUS <> 0 THEN
        BEGIN
          writeln('cannot get form ', comarea.nfname); halt;
        END;

     my_buf.fname := my_rec.fname;
     my_buf.lname := my_rec.lname;
     my_buf.phone := my_rec.phone;

     my_len := sizeof(my_buf);

     vputbuffer (comarea, my_buf, my_len);

     IF COMAREA.CSTATUS <> 0 THEN
        BEGIN
          writeln('putbuffer failed'); halt;
        END;
{
     VINITFORM (COMAREA);

     IF COMAREA.CSTATUS <> 0 THEN
        BEGIN
          writeln('initform failed'); halt;
        END;
}
     repeat

       VSHOWFORM (COMAREA);

       IF COMAREA.CSTATUS <> 0 THEN
          BEGIN
            writeln('showform failed'); halt;
          END;

       VREADFIELDS (COMAREA);

       IF COMAREA.CSTATUS <> 0 THEN
          BEGIN
            writeln('readfields failed'); halt;
          END;

       VFIELDEDITS (COMAREA);

       IF COMAREA.CSTATUS <> 0 THEN
          BEGIN
            writeln('fieldedits failed'); halt;
          END;

     until (comarea.lastkey <> 0) or (COMAREA.NUMERRS = 0);

     IF COMAREA.LASTKEY = 0 THEN
       begin

         VFINISHFORM (COMAREA);

         IF COMAREA.CSTATUS <> 0 THEN
            BEGIN
              writeln('fieldedits failed'); halt;
            END;

         my_len := sizeof(my_buf);

         VGETBUFFER (COMAREA, my_buf, my_len);

         IF COMAREA.CSTATUS <> 0 THEN
            BEGIN
              writeln('getbuffer failed'); halt;
            END;

         my_rec.fname := my_buf.fname;
         my_rec.lname := my_buf.lname;
         my_rec.phone := my_buf.phone;

         with my_rec do
           writedir (my_file, 1, my_rec);

       end;
{
     cmdimage := 'pause 10'#13;

     COMMAND(cmdimage, cmderror, parmnum);
}
     COMAREA.CSTATUS := 0;
     VCLOSETERM (COMAREA);

     COMAREA.CSTATUS := 0;
     VCLOSEFORMF (COMAREA);

     CLOSE (my_file);

     cli_exit;

     END.

