
       IDENTIFICATION DIVISION.

       PROGRAM-ID. COBOL-EXAMPLE.


       ENVIRONMENT DIVISION.

       INPUT-OUTPUT SECTION.

       FILE-CONTROL.

           SELECT my-file ASSIGN TO "MYFILE".


       DATA DIVISION.

       FILE SECTION.

       FD my-file.

       01 my-rec.
           05 fname               PIC X(20).
           05 lname               PIC X(20).
           05 phone               PIC X(20).

       WORKING-STORAGE SECTION.

       01 COMAREA.
           05  CSTATUS             PIC S9(4) COMP VALUE 0.
           05  LANGUAGE            PIC S9(4) COMP VALUE 0.
           05  COMAREALEN          PIC S9(4) COMP VALUE 0.
           05  USERBUFLEN          PIC S9(4) COMP VALUE 0.
           05  CMODE               PIC S9(4) COMP VALUE 0.
           05  LASTKEY             PIC S9(4) COMP VALUE 0.
           05  NUMERRS             PIC S9(4) COMP VALUE 0.
           05  WINDOWENH           PIC S9(4) COMP VALUE 0.
           05  MULTIUSAGE          PIC S9(4) COMP VALUE 0.
           05  LABELOPTIONS        PIC S9(4) COMP VALUE 0.
           05  CFNAME              PIC X(16)      VALUE SPACES.
           05  NFNAME              PIC X(16)      VALUE SPACES.
           05  REPEATAPP           PIC S9(4) COMP VALUE 0.
           05  FREEZEAPP           PIC S9(4) COMP VALUE 0.
           05  CFNUMLINES          PIC S9(4) COMP VALUE 0.
           05  DBUFLEN             PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  LOOKAHEAD           PIC S9(4) COMP VALUE 0.
           05  DELETEFLAG          PIC S9(4) COMP VALUE 0.
           05  SHOWCONTROL         PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  PRINTFILENUM        PIC S9(4) COMP VALUE 0.
           05  FILERRNUM           PIC S9(4) COMP VALUE 0.
           05  ERRFILENUM          PIC S9(4) COMP VALUE 0.
           05  FORMSTORESIZE       PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  NUMRECS             PIC S9(8) COMP VALUE 0.
           05  RECNUM              PIC S9(8) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  TERMFILEN           PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  FILLER              PIC S9(4) COMP VALUE 0.
           05  RETRIES             PIC S9(4) COMP VALUE 0.
           05  TERMOPTIONS         PIC S9(4) COMP VALUE 0.
           05  ENVIRON             PIC S9(4) COMP VALUE 0.
           05  USERTIME            PIC S9(4) COMP VALUE 0.
           05  IDENTIFIER          PIC S9(4) COMP VALUE 0.
           05  LABELINFO           PIC S9(4) COMP VALUE 0.

       01 my-buf.
           05 fname               PIC X(20).
           05 lname               PIC X(20).
           05 phone               PIC X(20).

       01 my-len                  pic s9(4) comp value 60.

       01 formfile  pic x(30)  value "formfile ".
       01 termfile  pic x(30)  value "termfile ".


       PROCEDURE DIVISION.

       main-program.

           call "cli_init".

           MOVE ZERO TO LANGUAGE OF COMAREA.
           MOVE 60 TO COMAREALEN OF COMAREA.
           MOVE 1 TO LABELOPTIONS OF COMAREA.
           MOVE ZERO TO LOOKAHEAD OF COMAREA.
           MOVE 4 TO FORMSTORESIZE OF COMAREA.

           OPEN i-o my-file.

           read my-file
             at end initialize my-rec
           end-read.

           CALL "vopenformf" USING COMAREA, formfile.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "cannot open formfile"
             stop run
           end-if.

           CALL "vopenterm" USING COMAREA, termfile.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "cannot open termfile"
             stop run
           end-if.

           MOVE "MY_FORM" TO NFNAME OF COMAREA.

           CALL "vgetnextform" USING COMAREA.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "cannot get form " nfname of comarea
             go to skip-update
           end-if.

           move corr my-rec to my-buf.

           call "vputbuffer" using comarea, my-buf, my-len.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "putbuffer failed"
             go to skip-update
           end-if.

      *    CALL "vinitform" USING COMAREA.

      *    IF CSTATUS OF COMAREA NOT = 0 then
      *      display "initform failed"
      *      go to skip-update
      *    end-if.

       show-again.

           CALL "vshowform" USING COMAREA.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "showform failed"
             go to skip-update
           end-if.

           CALL "vreadfields" USING COMAREA.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "readfields failed"
             go to skip-update
           end-if.

           CALL "vfieldedits" USING COMAREA.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "fieldedits failed"
             go to skip-update
           end-if.

           IF (lastkey of comarea = 0)
             and (NUMERRS OF COMAREA not = 0)
           then
      *      need VERRMSG and VSETERROR or VPUTWINDOW here !?
             go to show-again
           end-if.

           IF LASTKEY OF COMAREA not = 0 then
             go to skip-update
           end-if.

           CALL "vfinishform" USING COMAREA.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "finishform failed"
             go to skip-update
           end-if.

           CALL "vgetbuffer" USING COMAREA, my-buf, my-len.

           IF CSTATUS OF COMAREA NOT = 0 then
             display "getbuffer failed"
             go to skip-update
           end-if.

           move corr my-buf to my-rec.

           rewrite my-rec.

       skip-update.

           MOVE 0 to CSTATUS OF COMAREA.
           CALL "vcloseterm" USING COMAREA.

           MOVE 0 to CSTATUS OF COMAREA.
           CALL "vcloseformf" USING COMAREA.

           CLOSE my-file.

           call "cli_exit".

           stop run.

       end program cobol-example.

